// !     asm("sleep"); !
//--------------------

#include "clock_lcd.h"
#include "lcd.h"


void adc_in_lcd(uint8_t x, uint8_t y);
void str_mes_in_lcd(uint8_t x, uint8_t y);
void str_day_in_lcd(uint8_t x, uint8_t y);
void hh_mm_ss(uint8_t x, uint8_t y, uint8_t *prt ,uint8_t ss, uint8_t miganie_linii);
void tempir_in_bcd(signed int t,  unsigned char pin_wire, uint8_t x, uint8_t y);
void str_pog_in_lcd(uint8_t x, uint8_t y);
void format_1(uint8_t kanal);
void format_2(uint8_t kanal);

//**************************************
ISR(SIG_OVERFLOW2)
{
 clock_++;
 if (clock_==128)
	{	   	 		  	   	  				   	
	clock_=0;
	hour[h_sek]++;
  	}
}

void adc_init(void)
{
	#define ADMUXSETTING	( BIT(REFS1)|BIT(REFS0) ) /*Internal 2.56V Voltage Reference with external capacitor at AREF pin*/
	//#define ADMUXSETTING	( BIT(REFS0) )/*AVCC with external capacitor at AREF pin*/
	//#define ADMUXSETTING	0
	ADMUX=ADMUXSETTING;//Internal 2.56V Voltage Reference with external capacitor at AREF pin
	ADCSRA=BIT(ADEN)|BIT(ADPS2)|BIT(ADPS1);//clock/64=16uSek
}
//--------------------------------------
void adc_off(void)
{
	ADCSRA=0;
	ADMUX=0;
}

//--------------------------------------
void port_init(void)
{
	PORTKEY=KEY;
	BUDIL_SIG_INIT;
	PORT_POWER_DETECT|=_power_;
	LCD_POWER_INIT;
}

//**************************************
void timer2_init(void)
{
	TCCR2 = 0x00; 		  //stop
	ASSR  = (1<<AS2);	  //set async mode
	TCCR2 = 0x01; 		  //start
}
//**************************************
void timer1_init(void)
{
	TCCR1B = 0; //stop
	TCCR1A	= 0;
	DDR_OC1A  &=~ OC1A;	  //OC1A 
	PORT_OC1A &=~ OC1A;
}

void shim_true(void)
{
	DDR_OC1A |= OC1A;		//OC1A
	TCCR1B = 0; 			//stop
	TCCR1A = (1<<COM1A0);	//Toggle OC1A/OC1B on Compare Match //TCCR1B WGM12=1 CTC top-OCR1A
	TCCR1B=(1<<CS10)|(1<<WGM12);

}

void init_devices(void)
{
	cli();
	port_init();
	adc_init();
	timer1_init();
	MCUCR = 0x00;
	GICR  = 0x00;
	ACSR=BIT(ACD);
	TIMSK =(1<<TOIE2); //timer interrupt sources
	sei(); 
}

//   
unsigned char EEPROM_READ(unsigned int uiAddress)
{
	while(EECR & (1<<EEWE));/*     */
	EEAR = uiAddress;/*    */
	EECR |= (1<<EERE);/*       EERE */
	return EEDR;/*      */
}

void EEPROM_write(unsigned int uiAddress, unsigned char ucData)
{
	if ( EEPROM_READ(uiAddress)!=ucData){
		/*     */
		while(EECR & (1<<EEWE));
		cli();
		/*     */
		EEAR = uiAddress;
		EEDR = ucData;
		/*  . 1   EEMWE */
		EECR |= (1<<EEMWE);
		/*       EEWE */
		EECR |= (1<<EEWE);
		sei();
		}
}
//*********************************************
void read_data_EEPROM(void)
{
unsigned char  *a, i;
unsigned int crc=0;
	a=(unsigned char *)&setup;
	for( i=EEPROM_ADR ; i<sizeof(setup)+EEPROM_ADR; i++, a++){
		*a=EEPROM_READ(i);
		if (i<sizeof(setup)-2){
			crc+=*a;
			}
		}
	if ( crc!=setup.crc ) eeprom_err=1;
}

void EEPROM_save_parametr_all( void )
{
 unsigned char i, *p;
 
	if (time_flag & fl_eeprom_write)
	{
	time_flag&= ~fl_eeprom_write;
	setup.crc=eeprom_err=0;
	
	p=(unsigned char *) &setup;
	for(i=EEPROM_ADR; i<sizeof(setup)+EEPROM_ADR ; i++, p++){
		EEPROM_write( i, *p );
		if (i<sizeof(setup)-2)
			setup.crc+=*p;
		}
	}
}


//------------DALLAS------------------
void pullup_off(void){
	DDR_1wire&=~pwire0;
	DDR_1wire&=~pwire1;
	PORT_1wire&=~pwire0;
	PORT_1wire&=~pwire1;
}

unsigned char readbit(void){
unsigned char i;
	cli();
	DDR_1wire|=out_1wire;//line down

	asm("nop");
	asm("nop");//1.25us
	DDR_1wire&=~out_1wire;//line up through 1.25us
	_delay_us(12);
	i=PIN_1wire;
	sei();
	_delay_us(47);
	return i;
}

void readbyte(unsigned char *pw) {
unsigned char i,r,p;//, a;

	pw[0]=pw[1]=0;
	pullup_off();
	for(i=0, r=1; i<8; i++){
	p=readbit();
	if ( p & pwire0 ) pw[0]|=r; 
	if ( p & pwire1 ) pw[1]|=r; 
	r<<=1;	
	}
PORT_1wire|=power_suplly_1w;
DDR_1wire|=power_suplly_1w;
}

//------------------------------------------------
void writebit0(void){
	cli();
	DDR_1wire|=out_1wire;
	_delay_us(60);
	DDR_1wire&=~out_1wire;
	sei();
}
//***********************************************
void writebit1(void){
	cli();
	DDR_1wire|=out_1wire;
	_delay_us(3);
	DDR_1wire&=~out_1wire;
	sei();
	_delay_us(57);
}
//***********************************************
void writebyte(unsigned char byte){
unsigned char i;
	pullup_off();
	for(i=0; i<8; i++){
		if (byte&BIT(0)) 
			writebit1();
			else
			writebit0();
		byte>>=1;
		}
	PORT_1wire|=power_suplly_1w;
	DDR_1wire|=power_suplly_1w;
}

void detectPresence(void){
unsigned char i;
	
	pullup_off();
	out_1wire=pwire0|pwire1;
	
	DDR_1wire|=pwire0;
	DDR_1wire|=pwire1;
	_delay_ms(0.48);//0.48
	
	cli();
	DDR_1wire&=~pwire0;
	DDR_1wire&=~pwire1;
	_delay_us(60);//60
	i=PIN_1wire;
	sei();
	
	if ( i & pwire0 ) out_1wire&=~pwire0;
	if ( i & pwire1 ) out_1wire&=~pwire1;

	if ( out_1wire == 0 ){
		count_com_1w=0; 
//		data_ok|=data_temperature;
		return;
		}
	
	_delay_ms(0.42);//0.42
	i=PIN_1wire;
	if (!( i & pwire0 )) out_1wire&=~pwire0;
	if (!( i & pwire1 )) out_1wire&=~pwire1;
	
	if ( out_1wire == 0 ){
		count_com_1w=0; 
//		data_ok|=data_temperature;
		return;
		}
			
	power_suplly_1w &= out_1wire;
	PORT_1wire|=power_suplly_1w;
	DDR_1wire|=power_suplly_1w;	
}

//****************************************
void scratchpad_save(void){

	detectPresence();//  
	writebyte(0xCC);//SKIP ROM [CCh]
	writebyte(0x4E);//WRITE SCRATCHPAD [4Eh]
	writebyte(5);//	TH
	writebyte(5);//	TL
	writebyte(0x7F);//	Statys 12bit
		
	detectPresence();//   EEPROM
	writebyte(0xCC);//SKIP ROM [CCh]
	writebyte(0x48);//COPY SCRATCHPAD [48h]
	PORT_1wire|=power_suplly_1w;
	DDR_1wire|=power_suplly_1w;
}

//**************************************************
void format_t(unsigned char p){
int t_point;
	t_point=(unsigned int)(tempir_msb[p]<<8);//msb
	t_point|=tempir_lsb[p];//lsb;
	tempiratura[p]=( t_point*10/16 );// + setup.correct_ds[p];

}	
//**************************************************
void izmerenie_t(void)
{
if ( !count_com_1w ){//
	count_com_1w++;
	power_suplly_1w=0;
	detectPresence();//  
	}
	else
	if ( count_com_1w==1 ){
		count_com_1w++;
	
		writebyte(0xCC);//SKIP ROM [CCh]
		writebyte(0xB4);//READ POWER SUPPLY [B4h]
		pullup_off();
		
		power_suplly_1w=readbit();//     
		power_suplly_1w=~power_suplly_1w;//    ,  
		power_suplly_1w &= out_1wire;//pwire0|pwire1;
		}
	else
	if ( count_com_1w==2 ){	// 
		count_com_1w++;
		detectPresence();//
		}
	else
	if ( count_com_1w==3 ){
		count_com_1w++;
		writebyte(0xCC);//SKIP ROM [CCh]
		writebyte(0x44);//CONVERT T [44h]
		time[wire1]=125;//1sek
		}
	else
	if ( count_com_1w==4 ){
		if (time[wire1]<-10) count_com_1w++;
		}
	else
	if ( count_com_1w==5 ){// 
		count_com_1w++;
		detectPresence();//
		}
	else
	if ( count_com_1w==6 ){
		count_com_1w++;
		writebyte(0xCC);//SKIP ROM [CCh]
		writebyte(0xBE);//READ SCRATCHPAD [BEh]
		}
	else
	if ( count_com_1w==7 ){
		count_com_1w=0;

		readbyte(tempir_lsb);//LSB   
		readbyte(tempir_msb);//MSB   
		format_t(0);
		format_t(1);
//		data_ok|=data_temperature;
		}
}
//*************** END 1 Wire ***************************************************

//*************************************************************

void skankey (void){
	unsigned char key_lokal=17;
	
	key=key_lokal;

	if 		(KEY_F)	    	key_lokal=1;
	else if	(KEY_SET)		key_lokal=2;
	else if	(KEY_PLUS)		key_lokal=3;
	else if	(KEY_MINUS)		key_lokal=4;
	else 					key_lokal=17;
	
	if ( key_lokal!=17 )
	{
	anti_drebezg[0]++;
	if (anti_drebezg[0]==5)//35)
		{
		key=key_lokal;
			OCR1A=0x0400;
			shim_true();//
			time_flag|= fl_sig_butt ;//fl_sek_1_switch;
			time[note_but]=5;
		}
	if (anti_drebezg[0]==anti_drebezg[2]){	//anti_drebezg[0]  
		anti_drebezg[0]=0;					//anti_drebezg[1] -   
		anti_drebezg[1]++;					//anti_drebezg[2]    
		if (anti_drebezg[1]==3) anti_drebezg[2]=10;//55;
		}	
	time_in_regim=25;
	}
	else
	{
	anti_drebezg[0]=0;
	anti_drebezg[1]=0;
	anti_drebezg[2]=50;
	}
}


//**************************************
void inc_dec_var(uint8_t *var, uint8_t limit){
	if (PLUS){
		if ((*var)<limit)	(*var)++; 
		else *var=0;
		}
	if (MINUS){
		if (*var) (*var)--;
		else *var=limit;
		}
}

//**************************************
void mask_next_regim(unsigned char next_F,unsigned char SET)
{
	if (F_)   {regim=next_F;lcd_instructions_set(clear_display);lcd_instructions_set(cursor_off);}
	if (SET_) {regim=SET;lcd_instructions_set(clear_display);}
	key=17;
}

void next_regim(void){
	if (PLUS) {
		if (regim<END_REGIM) 
		regim++;
		lcd_instructions_set(clear_display);
		} 
	if (MINUS) {
		if (regim>FIRST_REGIM)
		regim--;
		lcd_instructions_set(clear_display);
		} 
	p_index=0;
}

//**************************************
void key_action(void)
{
unsigned char *p,i;


	
if (key!=17) data_out_disable=0; else
	if ( (regim<FIRST_REGIM) && (regim>9) )
		if (time[data_out]<0){	//     
			time[data_out]=47;
			static uint8_t curs=0;
			curs=!curs;
			if (curs) lcd_instructions_set(cursor_lines);
			else lcd_instructions_set(cursor_off);
			}
			

	if ( regim == 0 ){ 
		p_index=x_index=0;
		
		if ( F_ )
			if (signal==3)	 {signal=0; lcd_instructions_set(cursor_off); return;}// 
			
		uint8_t j=FIRST_REGIM;
		if (eeprom_err) j=REG_SBROS_N;	
		if ( !(time_flag & fl_power_save) ){
			mask_next_regim(j,0);
			}
		
		return;
		}
	
	if (regim==REG_BUDILNIK_ON){
		if ( F_ ){ //   
			regim=signal=0;
			BUDIL_SIG_OFF;
			lcd_instructions_set(clear_display);
			lcd_instructions_set(cursor_off);
			}
		if (( PLUS )||( MINUS )||( SET_ )){// 
			BUDIL_SIG_OFF;
			regim=0;
			if (signal>1){
				signal=3;
				time_signal=0xFF;
				budilnik_play_num=0;
				}
				else
				signal=0;
			lcd_instructions_set(clear_display);
			lcd_instructions_set(cursor_off);
			}
		return;
		}
	//----------------------------
	if (regim==REG_BUDILNIK){
		next_regim();
		mask_next_regim(0,r_budilnik);	
		return;
		}
	if (regim==r_budilnik) {
		inc_dec_var(&p_index, kol_vo_sig_bud-1);
		mask_next_regim( 0,r_budilnik+1);	
		lcd_set_address(10,1);
		return;
		}
	if (regim==r_budilnik+1) {//   - /
		inc_dec_var(&setup.budilnik[p_index][_sig], 2 );
		mask_next_regim(r_budilnik,r_budilnik+2);	
		lcd_set_address(16,1);
		return;
		}
	if (regim==r_budilnik+2) {//   - 
		inc_dec_var(&setup.budilnik[p_index][h_hour], 23);
		mask_next_regim(r_budilnik,r_budilnik+3);	
		lcd_set_address(14,2);
		return;
		}
	if (regim==r_budilnik+3) { //   
		inc_dec_var(&setup.budilnik[p_index][h_min], 59);
		mask_next_regim(r_budilnik,r_budilnik+4);	
		lcd_set_address(17,2);
		return;
		}
	if (regim==r_budilnik+4) { //   -  
		if (SET_) if (++x_index==7) 
		{	x_index=0; 
			regim=r_budilnik; 
			if (p_index>=kol_vo_sig_bud) 
			{	mask_next_regim(r_budilnik,r_budilnik);//regim=r_budilnik+5;
			}
		}
		if (F_) {regim=r_budilnik; }
		if ((PLUS)||(MINUS)) setup.budilnik[p_index][h_day]^=_BV(x_index);
		lcd_set_address(x_index+13,3);
		return;
		}
	//---------------------------
	
	if (regim==REG_CLOCK) {
		next_regim();
		mask_next_regim(0,r_clock);//	
		return;
		}

	if (regim==r_clock) {// 
		inc_dec_var(&hour[h_hour],23);
		lcd_set_address(7,1);
		mask_next_regim(REG_CLOCK,r_clock+1);	
		return;
		}
	if (regim==r_clock+1) {// 
		inc_dec_var(&hour[h_min],59);
		lcd_set_address(10,1);
		mask_next_regim(REG_CLOCK,r_clock+2);	
		return;
		}
	if (regim==r_clock+2) {// 
		if (MINUS){
		   if (hour[h_sek]>31) hour[h_min]++;
		   hour[h_sek]=0;
		   clock_=0;
		   }
		lcd_set_address(13,1);
		mask_next_regim(REG_CLOCK,r_clock+3);	
		return;
		}
	
	if (regim==r_clock+3) {// 
		inc_dec_var(&hour[h_num],30);
		lcd_set_address(6,2);
		mask_next_regim(REG_CLOCK,r_clock+4);	
		return;
		}
	if (regim==r_clock+4) {// 
		inc_dec_var(&hour[h_month],11);
		lcd_set_address(9,2);
		mask_next_regim(REG_CLOCK,r_clock+5);	
		return;
		}
	if (regim==r_clock+5) {// 
		inc_dec_var(&hour[h_year],99);
		lcd_set_address(14,2);
		mask_next_regim(REG_CLOCK,r_clock+6);	
		return;
		}
	if (regim==r_clock+6) {//  
		inc_dec_var(&hour[h_day],7-1);
		lcd_set_address(12,3);
		mask_next_regim(REG_CLOCK,r_clock+7);	
		return;
		}
	if (regim==r_clock+7) {//  
	 	inc_dec_var(&setup.regim_state_time[view_regim_state*2],Nreg_st/2-1);
		lcd_set_address(18,3);
	 	mask_next_regim(REG_CLOCK,r_clock+8);
		return;
		}
		
	if (regim==r_clock+8) {//  
	 	inc_dec_var(&setup.corr_flag, 1);
		lcd_set_address(11,4);
	 	mask_next_regim(REG_CLOCK,r_clock+9);
		return;
		}
	if (regim==r_clock+9) {//  
	 	inc_dec_var(&setup.correction,sizeof(corr_in_lcd)/2-1);
		lcd_set_address(14,4);
	 	mask_next_regim(REG_CLOCK,REG_CLOCK);
		return;
		}

	//===========================
	
	if (regim==REG_YST_POG) {
		next_regim();
		mask_next_regim(0,r_yst_pog);//	
		return;
		}
	if (regim==r_yst_pog) {//  
		inc_dec_var(&setup.shtorm_ot,60);
		lcd_set_address(11,1);
		mask_next_regim(REG_YST_POG,r_yst_pog+1);	
		return;
		}
	if (regim==r_yst_pog+1) {//  
		inc_dec_var(&setup.shtorm_do,60);
		lcd_set_address(19,1);
		mask_next_regim(REG_YST_POG,r_yst_pog+2);	
		return;
		}
//	if (regim==r_yst_pog+2) {//  
//		inc_dec_var(&setup.shtorm_do,60);
//		lcd_set_address(11,2);
//		mask_next_regim(REG_YST_POG,r_yst_pog+3);	
//		return;
//		}
	if (regim==r_yst_pog+2) {//  
		inc_dec_var(&setup.dojd_do,60);
		lcd_set_address(19,2);
		mask_next_regim(REG_YST_POG,r_yst_pog+3);	
		return;
		}
//	if (regim==r_yst_pog+4) {//  
//		inc_dec_var(&setup.dojd_do,60);
//		lcd_set_address(11,3);
//		mask_next_regim(REG_YST_POG,r_yst_pog+5);	
//		return;
//		}
	if (regim==r_yst_pog+3) {//  
		inc_dec_var(&setup.obl_do,60);
		lcd_set_address(19,3);
		mask_next_regim(REG_YST_POG,r_yst_pog+4);	
		return;
		}
//	if (regim==r_yst_pog+6) {// . 
//		inc_dec_var(&setup.obl_do,60);
//		lcd_set_address(11,4);
//		mask_next_regim(REG_YST_POG,r_yst_pog+7);	
//		return;
//		}
	if (regim==r_yst_pog+4) {// . 
		inc_dec_var(&setup.mobl_do,60);
		lcd_set_address(19,4);
		mask_next_regim(REG_YST_POG,r_yst_pog+5);
		return;
		}
	
	if (regim==r_yst_pog+5) {//  
		inc_dec_var(&setup.yasno_ot,60);
		lcd_set_address(14,1);
		mask_next_regim(REG_YST_POG,r_yst_pog+6);	
		return;
		}
	if (regim==r_yst_pog+6) {// 
		inc_dec_var(&koef,40);
		lcd_set_address(14,2);
		mask_next_regim(REG_YST_POG,r_yst_pog+7);	
		return;
		}
	if (regim==r_yst_pog+7) {//  
		inc_dec_var(&corr_pog,10);
		lcd_set_address(14,3);
		mask_next_regim(REG_YST_POG,REG_YST_POG);	
		return;
		}
		
	//===========SBROC===================
	if (regim==REG_SBROS_N){//122
		next_regim();
		mask_next_regim(0,r_sbros_n);
		if (regim==0) lcd_instructions_set(clear_display);
		return;
		}	
	if (regim==r_sbros_n){
		lcd_set_address(0,0);
		mask_next_regim(REG_SBROS_N,r_sbros_n+1);
		if (regim==r_sbros_n+1){
			p=(unsigned char *) &setup;
			for(i=0; i<sizeof(setup) ; i++, p++)
				*p=0;
			lcd_instructions_set(clear_display);
			lcd_instructions_set(cursor_off);
			regim=0;
			}
		}	
}


//****************************************
void result_in_bcd(long int result)
{//0000 0000 0000 (1)0000  // (2)0000 (3)0000 (4)0000 (5)0000 hi2 hi3 low4 low5
    unsigned char dig_out=0;
	bcd_num0=0;
	bcd_num1=0;
	bcd_num2=0;
	bcd_num3=0;
	bcd_num4=0;
	while (result >= 10000) {
	 result -= 10000;
 	 dig_out ++;
	}
	bcd_num0=dig_out+0x30;
    dig_out = 0;
	while (result >= 1000) {
	 result -= 1000;
 	 dig_out ++;
	}
	bcd_num1=dig_out+0x30;
    dig_out = 0;
	while (result >= 100)  {
 	 result -= 100;
	 dig_out ++;
	 }
	bcd_num2=dig_out+0x30;
	dig_out = 0;
	while (result >= 10)   {
	 result -= 10;
	 dig_out ++;
	 }
	bcd_num3=dig_out+0x30;
	bcd_num4=result+0x30;
}
//**************************************
void num2_bcd_in_lcd(unsigned char param_out) //     
{	result_in_bcd(param_out);
	lcd_write_data(bcd_num3);
	lcd_write_data(bcd_num4);
}
void num1_bcd_in_lcd(unsigned char param_out)//     
{	unsigned char  n=' ';
	result_in_bcd(param_out);
	if ( bcd_num3!=0x30 ){ 
			n=bcd_num3; }
	lcd_write_data(n);
	lcd_write_data(bcd_num4);
}
//**************************************
void tempir_in_bcd(signed int t,  unsigned char pin_wire, uint8_t x, uint8_t y){
unsigned char  znak=0, n1=' ',n2=' ';
		
	lcd_set_address(x,y);
	if ( !(pin_wire & out_1wire) ){
	 	lcd_write_data(' ');
		lcd_write_data('-');
		lcd_write_data('-');
		lcd_write_data('-');
		lcd_write_data(' ');
		}
		else
		{
		if ( t<0 ){
			znak=1;
			result_in_bcd( t * -1 );
			}
		else {
			result_in_bcd( t );
			}

		if ( bcd_num1!=0x30 ) {
			n1=bcd_num1;
			n2=bcd_num2;
			}
		else
		{
		if ( bcd_num2!=0x30 ){ 
			n2=bcd_num2; 
			if ( znak ) n1='-';
			else n1='+';
			}
			else
			if ( znak ) n2='-';
			else n2='+';
		}

		lcd_write_data(n1);
		lcd_write_data(n2);
		lcd_write_data(bcd_num3);
		lcd_write_data(',');
		lcd_write_data(bcd_num4);

		}
}

void str_day_in_lcd(uint8_t x, uint8_t y){		//   .  -  
	lcd_set_address(x,y);
	lcd_write_data(str_day[hour[h_day]][0]);
	lcd_write_data(str_day[hour[h_day]][1]);
	lcd_write_data(str_day[hour[h_day]][2]);
	lcd_write_data(str_day[hour[h_day]][3]);
	lcd_write_data(str_day[hour[h_day]][4]);
	lcd_write_data(str_day[hour[h_day]][5]);
	lcd_write_data(str_day[hour[h_day]][6]);
	lcd_write_data(str_day[hour[h_day]][7]);
	lcd_write_data(str_day[hour[h_day]][8]);
	lcd_write_data(str_day[hour[h_day]][9]);
	lcd_write_data(str_day[hour[h_day]][10]);
}

void str_mes_in_lcd(uint8_t x, uint8_t y){		//   .  - 
	lcd_set_address(x,y);
	lcd_write_data(str_mes[hour[h_month]][0]);
	lcd_write_data(str_mes[hour[h_month]][1]);
	lcd_write_data(str_mes[hour[h_month]][2]);
	lcd_write_data(str_mes[hour[h_month]][3]);
	lcd_write_data(str_mes[hour[h_month]][4]);
	lcd_write_data(str_mes[hour[h_month]][5]);
	lcd_write_data(str_mes[hour[h_month]][6]);
	lcd_write_data(str_mes[hour[h_month]][7]);
	lcd_write_data(str_mes[hour[h_month]][8]);
}

void str_pog_in_lcd(uint8_t x, uint8_t y){		//   .  - 
	lcd_set_address(x,y);
	lcd_write_data(str_pogoda[bar[pogoda]][0]);
	lcd_write_data(str_pogoda[bar[pogoda]][1]);
	lcd_write_data(str_pogoda[bar[pogoda]][2]);
	lcd_write_data(str_pogoda[bar[pogoda]][3]);
	lcd_write_data(str_pogoda[bar[pogoda]][4]);
	lcd_write_data(str_pogoda[bar[pogoda]][5]);
	lcd_write_data(str_pogoda[bar[pogoda]][6]);
	lcd_write_data(str_pogoda[bar[pogoda]][7]);
	lcd_write_data(str_pogoda[bar[pogoda]][8]);
}

void str_chislo_in_lcd(uint8_t x, uint8_t y){	//   . - 
	lcd_set_address(x,y);
	num1_bcd_in_lcd(hour[h_num]+1);
}

void load_str(uint8_t *str){

	for(; *str!='\0' ;){
		lcd_write_data(*(str++));
		}
	if (regim>=FIRST_REGIM) lcd_instructions_set(cursor_off);
}

//**************************************
void view_in_indikator(unsigned char view){

	if 			(view==0)	format_1(1);
	else 	if 	(view==1)	format_2(1);
}

void adc_in_lcd(uint8_t x, uint8_t y){
	lcd_set_address(x,y);
	result_in_bcd(adc_rezult);//+setup.adc_ofset);
	lcd_write_data(bcd_num0);
	lcd_write_data(bcd_num1);
	lcd_write_data(bcd_num2);
}

void num_day(uint8_t x, uint8_t y){//   
	lcd_set_address(x,y);
	num2_bcd_in_lcd(hour[h_num]+1);
	lcd_write_data('.');
	num2_bcd_in_lcd(hour[h_month]+1);
	lcd_write_data('.');
	lcd_write_data('2');
	lcd_write_data('0');
	num2_bcd_in_lcd(hour[h_year]);
}

void num_day_short(uint8_t x, uint8_t y){//    
	lcd_set_address(x,y);
	num2_bcd_in_lcd(hour[h_num]+1);
	lcd_write_data('.');
	num2_bcd_in_lcd(hour[h_month]+1);
	lcd_write_data('.');
	num2_bcd_in_lcd(hour[h_year]);
}

void hh_mm_ss(uint8_t x, uint8_t y, uint8_t *prt ,uint8_t ss, uint8_t miganie_linii){
	//  -, y-, *prt-(,..), ss==1 -   0-, miganie_linii 1- 
	lcd_set_address(x,y);
	num1_bcd_in_lcd(*(prt+2));//hour[h_hour]*(prt+2)
	if (miganie_linii==0)
		lcd_write_data(':');
		else{
		if ( time_flag & fl_sek_1_switch )
			lcd_write_data(':'); else lcd_write_data(' ');
		}
	num2_bcd_in_lcd(*(prt+1));//hour[h_min]
	if (ss)
	{	lcd_write_data(':');
		num2_bcd_in_lcd(*prt);//hour[h_sek]
	}
}


//**************************************/
void data_lcd(void)
{
	//   SETUP
	//      ,    
	//           . key_action()
	//  
	
	if ( data_out_disable ) return;
	data_out_disable=1;
	
	if (regim){
		viewstate=0;
		time_view_buf = 3;
		}
	
	///---------- -------------------------------------
	if (regim==REG_CLOCK){
		lcd_set_address(5,2);
		load_str((uint8_t *)str_ust);
		lcd_set_address(7,3);
		load_str((uint8_t *)str_clock);
		return;
	    } 
	if ( (regim >= r_clock ) && (regim <= r_clock+9) ) 
		{
						
		hh_mm_ss(6,1,&hour[h_sek],1,0);// 
		num_day(5,2);					// . 
		
		lcd_set_address(0,3);
		load_str((uint8_t *)str_den);
		lcd_write_data(' ');
		load_str((uint8_t *)str_week);
		lcd_write_data(0x28);
		lcd_write_data(hour[h_day]+0x30+1);//  
		lcd_write_data(0x29);
		
		lcd_set_address(14,3);
		load_str((uint8_t *)str_vid);		// 
		lcd_write_data(0x28);
		lcd_write_data(setup.regim_state_time[view_regim_state*2] +1+0x30);
		lcd_write_data(0x29);		
		
		lcd_set_address(0,4);
		load_str((uint8_t *)str_corr);
		lcd_write_data(' ');
		lcd_write_data(0x28);
		if ( setup.corr_flag )	lcd_write_data('+'); else lcd_write_data('-');//   
		result_in_bcd( pgm_read_word_near(&corr_in_lcd[setup.correction]) );// 
		lcd_write_data(bcd_num2);
		lcd_write_data(bcd_num3);
		lcd_write_data(bcd_num4);
		lcd_write_data(0x29);
		lcd_write_data('m');
		lcd_write_data('S');
		return;
		}
	
	//-----------------------------------------
	if (regim==REG_BUDILNIK_ON){
		lcd_instructions_set(clear_display);
		lcd_set_address(1,1);
		load_str((uint8_t *)str_bud_on);	//   !!!!
		hh_mm_ss(7,2,&hour[h_sek],0,0);	// 
		lcd_set_address(5,4);
		load_str((uint8_t *)str_budil_num);// 
		lcd_write_data(' ');
		lcd_write_data(budilnik_nomer+0x30+1);// 
		return;
		}
	if (regim==REG_BUDILNIK){
		lcd_set_address(5,2);
		load_str((uint8_t *)str_ust);
		lcd_set_address(4,3);
		load_str((uint8_t *)str_budil);
		return;
		}
	
	if ( (regim >= r_budilnik ) && (regim <= r_budilnik+9) )
		{
		lcd_set_address(0,1);
		load_str((uint8_t *)str_budil_num);
		lcd_write_data(' ');
		lcd_write_data(0x30+p_index+1);
		lcd_write_data(' ');
		lcd_write_data(' ');
		lcd_write_data(' ');
	
		if (setup.budilnik[p_index][_sig]==0){
		load_str((uint8_t *)str_off);
		}else
		if (setup.budilnik[p_index][_sig]==1){
		load_str((uint8_t *)str_on);
		}else
		load_str((uint8_t *)str_ots);
		
		lcd_set_address(0,2);
		load_str((uint8_t *)str_time);
		hh_mm_ss(13, 2, &setup.budilnik[p_index][h_sek] ,0,0);
	
		lcd_set_address(0,3);
		load_str((uint8_t *)str_den);
		lcd_write_data(' ');
		load_str((uint8_t *)str_week);
		lcd_write_data(' ');
		lcd_write_data(' ');
		
		for (uint8_t i=0; i<7; i++)
		{	if ( setup.budilnik[p_index][h_day] & BIT(i) )
			lcd_write_data(0x31+i); 
			else lcd_write_data('_');
			}
		//if (p_index>=4)
		//	{ p_index = -1;}
		return;
		}
	
	//===========================
	
	if (regim==REG_YST_POG) {
		lcd_set_address(5,2);
		load_str((uint8_t *)str_ust);
		lcd_set_address(5,3);
		load_str((uint8_t *)str_davl);
		return;
		}
		
	if ( (regim >= r_yst_pog ) && (regim <= r_yst_pog+4) ) 
		{
		lcd_set_address(0,1);				
		load_str((uint8_t *)str_shtorm);// 
		lcd_set_address(6,1);	
		load_str((uint8_t *)str_ot);
		lcd_write_data(' ');
		lcd_write_data('7');
		num2_bcd_in_lcd(setup.shtorm_ot);
		lcd_set_address(14,1);	
		load_str((uint8_t *)str_do);
		lcd_write_data(' ');
		lcd_write_data('7');
		num2_bcd_in_lcd(setup.shtorm_do);
		
		lcd_set_address(0,2);				
		load_str((uint8_t *)str_dojd);// 
		lcd_set_address(6,2);	
		load_str((uint8_t *)str_ot);
		lcd_write_data(' ');
		lcd_write_data('7');
		num2_bcd_in_lcd(setup.shtorm_do);
		lcd_set_address(14,2);	
		load_str((uint8_t *)str_do);
		lcd_write_data(' ');
		lcd_write_data('7');
		num2_bcd_in_lcd(setup.dojd_do);
		
		lcd_set_address(0,3);				
		load_str((uint8_t *)str_obl);// 
		lcd_set_address(6,3);	
		load_str((uint8_t *)str_ot);
		lcd_write_data(' ');
		lcd_write_data('7');
		num2_bcd_in_lcd(setup.dojd_do);
		lcd_set_address(14,3);	
		load_str((uint8_t *)str_do);
		lcd_write_data(' ');
		lcd_write_data('7');
		num2_bcd_in_lcd(setup.obl_do);
		
		lcd_set_address(0,4);				
		load_str((uint8_t *)str_mobl);// .
		lcd_set_address(6,4);	
		load_str((uint8_t *)str_ot);
		lcd_write_data(' ');
		lcd_write_data('7');
		num2_bcd_in_lcd(setup.obl_do);
		lcd_set_address(14,4);	
		load_str((uint8_t *)str_do);
		lcd_write_data(' ');
		lcd_write_data('7');
		num2_bcd_in_lcd(setup.mobl_do);
		}
	
	if ( (regim >= r_yst_pog+5 ) && (regim <= r_yst_pog+8) ){
		lcd_set_address(0,1);				
		load_str((uint8_t *)str_yasno);// 
		lcd_set_address(9,1);	
		load_str((uint8_t *)str_ot);
		lcd_write_data(' ');
		lcd_write_data('7');
		num2_bcd_in_lcd(setup.yasno_ot);
		
		
		lcd_set_address(0,2);				
		load_str((uint8_t *)str_koef);// 
		lcd_set_address(13,2);	
		num2_bcd_in_lcd(koef);
			
		lcd_set_address(0,3);				
		load_str((uint8_t *)str_corr);// 
		lcd_set_address(11,3);	
		lcd_write_data(' ');
		lcd_write_data('+');
		num2_bcd_in_lcd(corr_pog);
		}
		
		//------------------------------------------
	if (regim==REG_SBROS_N){
		lcd_set_address(7,2);
		load_str((uint8_t *)str_sbros);
			return;
		}
	if (regim==r_sbros_n){
		lcd_set_address(2,2);
		load_str((uint8_t *)str_sbros_aply);
		}	
		
}

//**************************************
void calls_verify(void)
{
unsigned char i;

	for(i=0;i<kol_vo_sig_bud;i++)
		if ( setup.budilnik[i][_sig] )//  
		  if ( setup.budilnik[i][h_day] & _BV(hour[h_day]) )//
			if (setup.budilnik[i][h_hour]==hour[h_hour])//
				if (setup.budilnik[i][h_min]==hour[h_min])//
				 {
					BUDIL_SIG_ON;
					
					regim=REG_BUDILNIK_ON; data_out_disable=0;
					time_signal=time_in_regim=59;
					signal=setup.budilnik[i][_sig];
					budilnik_nomer=i;
					budilnik_play_num=0;//           
				 }
}

void signal_verify(void){
	if (signal){
		if ( time_signal==0 ){
			BUDIL_SIG_OFF;
			if (signal==1) {//  
				signal=0;
				return;
				}
				else
			if (signal==2) {//  
				signal=3;
				time_signal=0xFF;
				}
				else
			if (signal==3) {
				if ( ++budilnik_play_num==7 ) signal=0;
				else{
					BUDIL_SIG_ON;
					regim=REG_BUDILNIK_ON; data_out_disable=0;
					time_signal=time_in_regim=59;
					signal=2;
					}
				}
			}
		
		}
}


//**************************************
void clock(void){

 if (hour[h_sek]==60)
	{
   	hour[h_sek] =0;
	hour[h_min]++;
	if (hour[h_min]==60)
		{
		hour[h_min] =0;
		hour[h_hour]++;
		
		if ( setup.corr_flag )// 
   		   clock_+=setup.correction;// 
   		   else
   		   clock_= 0x00-setup.correction;
		
		if (hour[h_hour]==24)
			{
			hour[h_hour]=0;
			
			hour[h_day]++;
			hour[h_num]++;
			if (hour[h_day]>6)	hour[h_day]=0;
			if (hour[h_num]>=num_in_month[ hour[h_month]] )
				{
				hour[h_num]=0;
				hour[h_month]++;				
				if (hour[h_month]>11)
				{
				hour[h_month]=0;}
				
			if(hour[h_month]==0)
				{ hour[h_year]++;}
				}
			}
		}
	calls_verify();
	}
 		
}

void time_direct(void){
static unsigned char t, sek, adc_usr, t_sravn;
static unsigned long int rez, rez_pog;
unsigned char i;
	if ( t != clock_ )
		{//  0,0078125 .
		t=clock_;
		if (t==64) { //       0,5 
			time_flag^=fl_sek_1_switch;
			//data_ok|=data_clock;//    
			}
		for (i=0; i<4; i++) time[i]--;
		if ( time_flag & fl_sig_butt )
			if (time[note_but]<0)
			{
			timer1_init();
			time_flag&= ~ fl_sig_butt;
			}
		
		data_lcd();
		skankey();
		key_action();
		
		//------------ADC-----------------------
		ADMUX=ADMUXSETTING|0;
		ADCSRA|=BIT(ADSC);
		while ( !(ADCSRA & BIT(ADIF)) );//16uSek
			rez +=ADC;
		
		if ( ++adc_usr == 32 ) { //0,0078125 *25=0,1953125 
		//  ==32    ,      LCD,    	
			adc_usr=0;
			adc_rezult=(rez/32*(900+koef)/10)+corr_pog*10; // .  
			rez=0;
		//	data_ok|=data_adc;// ,    
			}
		if (hour[h_sek] ==0) //   
		{
		if (++t_sravn==1){		//  
		rez_h1=adc_rezult;
		t_sravn=0;		
		}
		}
		rez_pog=adc_rezult/100;

		if ((((setup.shtorm_ot+700)<=rez_pog))&&(rez_pog<=(setup.shtorm_do+700))) //
		{
		bar[pogoda]=0;
		}
		else
		if ((((setup.shtorm_do+700)<=rez_pog))&&(rez_pog<=(setup.dojd_do+700)))	//
		{
		bar[pogoda]=1;
		}
		else
		if ((((setup.dojd_do+700)<=rez_pog))&&(rez_pog<=(setup.obl_do+700)))	//
		{
		bar[pogoda]=2;
		}
		else
		if ((((setup.obl_do+700)<=rez_pog))&&(rez_pog<=(setup.mobl_do+700)))	//.
		{
		bar[pogoda]=3;
		}
		else
		if ((setup.yasno_ot+700)<=rez_pog)	//
		{
		bar[pogoda]=4;
		}
		//------------ADC-----------------------
		if (sek!=hour[h_sek]){// 
			sek=hour[h_sek];
			time_signal--;
			time_power_on--;
			
			signal_verify();
			
			if ( (regim >= r_clock ) && (regim <= r_clock+9) )  hh_mm_ss(6,1,&hour[h_sek],1,0);//      
		//	data_ok|=data_clock;// ,    
			}
		
		if (regim==0){
		//	format_1();
			if (!eeprom_err)
			view_in_indikator(viewstate);//  ,     
			else{
				time_view_buf=10;
				lcd_set_address(2,1);//   ,  error eeprom
				load_str((uint8_t *)str_eep);
				}
			}


//		if (regim==0){
//			viewstate=setup.regim_state_time[view_regim_state*2];
//			view_in_indikator(viewstate);//  ,     
//
//			}
		}
}

void znak_tend (void) { //   
	
		if (rez_h1 >= adc_rezult)
		{
		lcd_write_data (0xDA);		//
		}
		else
		lcd_write_data (' ');
		
		if ( rez_h1 <= adc_rezult)
		{
		lcd_write_data (0xD9);		//
		}
		else
		lcd_write_data (' ');
		
		}
		
void temperature_str(void){						//  
		LCDdefinechar(gradus, 0);					//     CGRAM
		lcd_set_address(0,3);
		lcd_write_data(0xBA);// 
		//load_str((uint8_t *)str_dom);
		tempir_in_bcd(tempiratura[0], pwire0,2,3);//  
		lcd_write_data(0);							//   CGRAM
		lcd_write_data('C');
		lcd_set_address(11,3);
		lcd_write_data(0x79);// 
		//load_str((uint8_t *)str_ul);
		tempir_in_bcd(tempiratura[1], pwire1,13,3);
		lcd_write_data(0);
		lcd_write_data('C');
		}

void format_1(uint8_t kanal){

//	if (data_ok & data_clock){
//		data_ok &= ~data_clock;
		hh_mm_ss(6,1,&hour[h_sek],1,0);// 
		num_day_short(0,2);				//   
		str_day_in_lcd(9,2);			//  
		temperature_str();
		lcd_set_address(1,4);
		znak_tend ();
		adc_in_lcd(4,4);
		lcd_write_data(0xBC);
		lcd_write_data(0xBC);
		str_pog_in_lcd(10,4);
		}
//}

void format_2(uint8_t kanal){

//	if (data_ok & data_clock){
//		data_ok &= ~data_clock;
		LCDdefinechar(gradus, 0);					//     CGRAM
		hh_mm_ss(1,1,&hour[h_sek],0,1);// 
		str_day_in_lcd(9,1);			//  
		str_chislo_in_lcd(2,2);			// 
		str_mes_in_lcd(5,2);			// 
		lcd_write_data('2');			// 
		lcd_write_data('0');			// 
		num2_bcd_in_lcd(hour[h_year]);	// 
		lcd_write_data(0xB4);			// 
		lcd_write_data(0x2E);			// .
		temperature_str();
		lcd_set_address(1,4);
		znak_tend ();
		adc_in_lcd(4,4);
		str_pog_in_lcd(10,4);
		}
	
//}
//**************************************
int main(void)
{
uint8_t power_on;	
	
	cli();
	read_data_EEPROM();
	timer2_init();
	init_devices();
	lcd_init();
	power_on=pin_power_;

while(1)
{
	clock();

	if (power_on)
	{//begin power on
		if ( time_flag & fl_power_save)
		{	time_flag&= ~ fl_power_save;
			LCD_POWER_INIT;
		}
		
		time_direct();
		izmerenie_t();	/* */	
		
		if (regim>=10) {//  eeprom     
			time_flag|= fl_eeprom_write;
			time_power_on=15; //       !
			}
		if (regim==0)
			EEPROM_save_parametr_all();


		
		if (pin_power_){//   
			if (time_power_on<=0) //      
			if ( !(time_flag & fl_sig_butt) ){ //     
				power_on=0;//   
				pullup_off(); 
				LCD_POWER_OFF;
				DDRLCD=0xFF;
				}
			} 
			else {power_on=1; time_power_on=0;}// ,      
 	
		if ( !(time_flag & fl_sig_butt) ){//        
			MCUCR = BIT(SM1)|BIT(SM0)|BIT(SE);
			asm("sleep");
			MCUCR=0;
			}	
		
	}//end power on
	else
	{//begin power off
	
	if	//((KEY_F)||(KEY_SET)||(!pin_power_)) {//       ,  .
		(!pin_power_){ //,   
		LCD_POWER_ON;
		time_flag|= fl_power_save;
		power_on=1;
		time_power_on=15; 
		time_view_buf=2;
		time_in_regim=2;
		regim=0;
		}
	else{
		MCUCR = BIT(SM1)|BIT(SM0)|BIT(SE);
		asm("sleep");
		MCUCR=0;
		}
		}//end power off
	}
}


