//***************************************
//  RC- 4.0000Mhz 
// mega8
//***************************************


#include <avr/io.h>
#include <avr/interrupt.h>
#include <util/delay.h> /*F_CPU = 4000000; _delay_ms max = 65,535ms; _delay_us max = 192us */
#include <avr/pgmspace.h>


#include "font.h"
#include "regim.h"

#define BIT _BV

#define PORTKEY	PORTC
#define PINKEY	PINC
#define DDRKEY	DDRC
//-------- time_flag byte -------
#define fl_sek_1_switch		BIT(3)
#define	fl_sig_butt		    BIT(2)//    
#define	fl_eeprom_write		BIT(3)
#define	fl_power_save		BIT(4)

#define KEY_F		( !(PINKEY & BIT(5)) )
#define KEY_SET		( !(PINKEY & BIT(4)) )
#define KEY_PLUS	( !(PINKEY & BIT(3)) )
#define KEY_MINUS	( !(PINKEY & BIT(2)) )
#define KEY			( BIT(2)|BIT(3)|BIT(4)|BIT(5) )

#define F_ 		   (key==1)
#define SET_ 	   (key==2)
#define PLUS 	   (key==3)
#define MINUS	   (key==4)


//*******PORT*******
#define OC1A	BIT(1)
#define DDR_OC1A	DDRB
#define PORT_OC1A	PORTB
#define PIN_calls_osn 	BIT(0)

//*******PORT*******
#define	PORT_1wire 		PORTB
#define	DDR_1wire 		DDRB
#define	PIN_1wire 		PINB

#define kolvo_datchikov	2
#define	pwire0 			BIT(4)	//PC4	
#define	pwire1 			BIT(5)	//PC5	
#define	pin_datchik		(pwire0|pwire1)

#define PORT_POWER_DETECT	PORTB
#define PIN_P_Dt			PINB
#define _power_			BIT(0)
#define pin_power_		( PIN_P_Dt & _power_ )

#define SIG_BUDILNIK	BIT(3)
#define BUDIL_SIG_INIT	DDRB|=_BV(3)
#define BUDIL_SIG_ON	PORTB|= SIG_BUDILNIK
#define BUDIL_SIG_OFF	PORTB&=~SIG_BUDILNIK

#define PINS_BUD	SIG_BUDILNIK//|PIN_BUDILNIK_1|PIN_BUDILNIK_2|PIN_BUDILNIK_3)



#define PORT_LCD_POWER	PORTD
#define DDR_LCD_POWER	DDRD
#define PIN_LCD_POWER	_BV(7)
#define LCD_POWER_INIT  DDR_LCD_POWER|=PIN_LCD_POWER; PORT_LCD_POWER|=PIN_LCD_POWER
#define LCD_POWER_ON	PORT_LCD_POWER|=PIN_LCD_POWER
#define LCD_POWER_OFF	PORT_LCD_POWER&=~PIN_LCD_POWER




//----------corr_flag---------
#define fl_corr_znak_pl	0

//----------------------------
#define	h_sek		0
#define	h_min		1
#define	h_hour		2
#define	h_day 		3
#define	h_num		4
#define	h_month		5
#define	h_year		6

#define pogoda		0

#define _sig		0

#define ds0	0
#define ds1	1

//---time[]---
#define wire1		0
#define note		1
#define note_but	2
#define data_out	3
//#define _skan_key_	3


unsigned char count_note;//,data_ok;
#define data_adc	_BV(0)
#define data_clock	_BV(1)
#define data_temperature	_BV(2)

uint8_t data_out_disable;
uint8_t key=17, znakomesto, regim, time_in_regim, anti_drebezg[3];
uint8_t time_flag;
uint8_t clock_, hour[]={0,0,12,0,0,0,9};//hour- month,num,day,hour,min,sek,year,
uint8_t bcd_num0, bcd_num1, bcd_num2, bcd_num3, bcd_num4;
uint8_t p_index, x_index, budilnik_nomer, signal, time_signal, budilnik_play_num;//, budilnik_pin_on[3];
uint8_t bar[]={3,2,1.0};
//uint8_t shtorm_ot=0, shtorm_do=10, dojd_ot=10, dojd_do=20, obl_ot=20, obl_do=30;//, mobl_ot=30, mobl_do=45;
//uint8_t yasno_ot=45;
uint8_t koef=28;
uint8_t corr_pog=0;

uint32_t adc_rezult, rez_h1, rez_h2;//,time_bud_pin[3];

uint8_t eeprom_err;
uint8_t viewstate, time_view_buf=1, view_regim_state; 
uint8_t tempir_lsb[kolvo_datchikov], tempir_msb[kolvo_datchikov], out_1wire, count_com_1w, power_suplly_1w;
int8_t time[4], time_power_on;
int16_t  tempiratura[kolvo_datchikov];//tmp_correct_ds[3],

 //const uint8_t  uprav_TCCR1B[4]={1|(1<<WGM12), 0|(1<<WGM12), 1|(1<<WGM12), 0|(1<<WGM12)}; 

#define kol_vo_sig_bud	8


struct	{
		uint8_t budilnik[kol_vo_sig_bud][4];//sig, hour, min, day
//		uint8_t bud_pin [kol_vo_pin_bud][3];
//		int16_t porog[4][2];
		#define Nreg_st	4//    *2      -    
		uint8_t regim_state_time[Nreg_st];
		uint8_t corr_flag;
		uint8_t correction;
		uint8_t shtorm_ot;
		uint8_t shtorm_do;
//		uint8_t dojd_ot;
		uint8_t dojd_do;
//		uint8_t obl_ot;
		uint8_t obl_do;
//		uint8_t mobl_ot;
		uint8_t mobl_do;
		uint8_t yasno_ot;
		int16_t adc_ofset;
		uint16_t crc;
} setup;

	

#define	ocr1ahi			0
#define	ocr1alow		1
#define	ocr1ahi_but		2
#define	ocr1alow_but	3

prog_int16_t	corr_in_lcd[51] =	{0,8,16,23,31,39,47,55,63,70,78,86,94,102,109,117,
									125,133,141,148,156,164,172,180,188,195,203,211,219,227,234,242,
									250,258,266,273,281,289,297,305,313,320,328,336,344,352,359,367,
									375,383,391};
						
const uint8_t 	num_in_month[12]={31,28,31,30,31,30,31,31,30,31,30,31};
const uint8_t 	length_note[4]={20,10,20,75}, uprav_TCCR1B[4]={1|(1<<WGM12), 0|(1<<WGM12), 1|(1<<WGM12), 0|(1<<WGM12)};


//-----------EEPROM-----------------
#define	EEPROM_ADR		7
